# Veth

This is an attempt to make veth interfaces work 
as if they were real interfaces for full network path simulation.

The topology being simulated is:

server - delay - middlebox - client

The veth devices are connected from right (.r) to left (.l).

server.r - delay.l - delay.r - mbox.l - mbox.r - client.l

By default, these networks are *not* attached to any real network,
so it is safe to use them in nearly any environment that allows you
to use network namespaces.

This example induces 10ms of one way delay and simulates an asymmetric
15Mbit/1Mbit link with 1000 buffers. It can be readily modified to do
other things, see qdisc_vdsl for one example.

# Setup

As root:

. settings.example
./vsetup.sh 
ip netns exec client netserver -N

# Example test 1

ip netns exec server netperf -H 10.10.2.2 # The client IP

# Example test 2

````
ip netns exec server tcpdump -i server.r -s 128 -w test.cap &
sleep 2 # Give tcpdump time to start
ip netns exec server netperf -H 10.10.2.2 # The client IP
killall -15 tcpdump
````

# Example test 3

````
ip netns exec server tcpdump -i server.r -s 128 -w server.cap &
ip netns exec client tcpdump -i client.l -s 128 -w client.cap &
sleep 2 # Give tcpdump time to start
ip netns exec server netperf -H fc02::2 # The client IPv6
killall -15 tcpdump
````
