#!/bin/bash

# Create the bridge
#ip link add br2 type bridge

# Create network namespaces and veth interfaces
# TOPOLOGY server - delay - mbox - client

for host in $HOSTS ; do
    ip netns add ${host}
done

ip link add server0.r type veth peer name delay0.l
ip link add server1.r type veth peer name delay1.l
ip link add server2.r type veth peer name delay2.l
ip link add server3.r type veth peer name delay3.l
ip link add delay.r type veth peer name isp.l
ip link add isp.r type veth peer name mbox.l
ip link add mbox.r type veth peer name client.l

ip link set dev server0.r netns server0
ip link set dev server1.r netns server1
ip link set dev server2.r netns server2
ip link set dev server3.r netns server3
ip link set dev delay.r netns delay
ip link set dev delay0.l netns delay
ip link set dev delay1.l netns delay
ip link set dev delay2.l netns delay
ip link set dev delay3.l netns delay
ip link set dev mbox.l netns mbox
ip link set dev mbox.r netns mbox
ip link set dev isp.l netns isp
ip link set dev isp.r netns isp
ip link set dev client.l netns client

ip netns exec server0 ip link set server0.r up
ip netns exec server1 ip link set server1.r up
ip netns exec server2 ip link set server2.r up
ip netns exec server3 ip link set server3.r up
ip netns exec delay ip link set delay.r up
ip netns exec delay ip link set delay0.l up
ip netns exec delay ip link set delay1.l up
ip netns exec delay ip link set delay2.l up
ip netns exec delay ip link set delay3.l up
ip netns exec isp ip link set isp.r up
ip netns exec isp ip link set isp.l up
ip netns exec mbox ip link set mbox.r up
ip netns exec mbox ip link set mbox.l up
ip netns exec client ip link set client.l up

# Assign IPs
#ip addr add 10.10.10.254/24 dev br2

ip netns exec server0 ip addr add 10.10.0.1/24 dev server0.r
ip netns exec server1 ip addr add 10.10.1.1/24 dev server1.r
ip netns exec server2 ip addr add 10.10.2.1/24 dev server2.r
ip netns exec server3 ip addr add 10.10.3.1/24 dev server3.r

ip netns exec delay ip addr add 10.10.0.2/24 dev delay0.l
ip netns exec delay ip addr add 10.10.1.2/24 dev delay1.l
ip netns exec delay ip addr add 10.10.2.2/24 dev delay2.l
ip netns exec delay ip addr add 10.10.3.2/24 dev delay3.l
ip netns exec delay ip addr add 10.11.0.1/24 dev delay.r

ip netns exec isp ip addr add 10.11.0.2/24 dev isp.l
ip netns exec isp ip addr add 10.12.0.1/24 dev isp.r

ip netns exec mbox ip addr add 10.12.0.2/24 dev mbox.l
ip netns exec mbox ip addr add 10.13.0.1/24 dev mbox.r

ip netns exec client ip addr add 10.13.0.2/24 dev client.l

