#!/bin/sh

set -x

host=client
ip netns exec ${host} tc qdisc add dev ${host}.l root fq_codel
ip netns exec ${host} ip route add default via 10.13.0.1 dev ${host}.l

# server

host=server0
ip netns exec ${host} tc qdisc add dev ${host}.r root fq
ip netns exec ${host} ip route add default via 10.10.0.2 dev ${host}.r
host=server1
ip netns exec ${host} tc qdisc add dev ${host}.r root fq
ip netns exec ${host} ip route add default via 10.10.1.2 dev ${host}.r
host=server2
ip netns exec ${host} tc qdisc add dev ${host}.r root fq
ip netns exec ${host} ip route add default via 10.10.2.2 dev ${host}.r
host=server3
ip netns exec ${host} tc qdisc add dev ${host}.r root fq
ip netns exec ${host} ip route add default via 10.10.3.2 dev ${host}.r

# delay

host=delay

ip netns exec ${host} ip route add 10.12.0.0/24 via 10.11.0.2
ip netns exec ${host} ip route add 10.13.0.0/24 via 10.11.0.2

# middlebox

host=isp
ip netns exec ${host} ip route add 10.10.0.0/24 via 10.11.0.1
ip netns exec ${host} ip route add 10.10.1.0/24 via 10.11.0.1
ip netns exec ${host} ip route add 10.10.2.0/24 via 10.11.0.1
ip netns exec ${host} ip route add 10.10.3.0/24 via 10.11.0.1
ip netns exec ${host} ip route add 10.13.0.0/24 via 10.12.0.2


host=mbox
ip netns exec ${host} ip route add 10.11.0.0/24 via 10.12.0.1
ip netns exec ${host} ip route add 10.10.0.0/24 via 10.12.0.1
ip netns exec ${host} ip route add 10.10.1.0/24 via 10.12.0.1
ip netns exec ${host} ip route add 10.10.2.0/24 via 10.12.0.1
ip netns exec ${host} ip route add 10.10.3.0/24 via 10.12.0.1

# let me ping localhost

for host in $HOSTS
do
ip netns exec ${host} ifconfig lo up
done
